libidn: punycode.h File Reference

libidn 1.33

Macros | Typedefs | Enumerations | Functions
punycode.h File Reference
`#include <stddef.h>`
`#include <idn-int.h>`

Go to the source code of this file.

## Macros
#define | IDNAPI

## Typedefs
typedef uint32_t | punycode_uint

## Enumerations
enum | punycode_status { punycode_success = 0, punycode_bad_input = 1, punycode_big_output = 2, punycode_overflow = 3 }
enum | Punycode_status { PUNYCODE_SUCCESS = punycode_success, PUNYCODE_BAD_INPUT = punycode_bad_input, PUNYCODE_BIG_OUTPUT = punycode_big_output, PUNYCODE_OVERFLOW = punycode_overflow }

## Functions
IDNAPI const char * | punycode_strerror (Punycode_status rc)
IDNAPI int | punycode_encode (size_t input_length, const punycode_uint input[], const unsigned char case_flags[], size_t *output_length, char output[])
IDNAPI int | punycode_decode (size_t input_length, const char input[], size_t *output_length, punycode_uint output[], unsigned char case_flags[])

## Macro Definition Documentation

## ◆ IDNAPI

#define IDNAPI

Definition at line 77 of file punycode.h.

## Typedef Documentation

## ◆ punycode_uint

typedef uint32_t punycode_uint

Definition at line 115 of file punycode.h.

## Enumeration Type Documentation

## ◆ punycode_status

enum punycode_status

Enumerator
punycode_success |
punycode_bad_input |
punycode_big_output |
punycode_overflow |

Definition at line 92 of file punycode.h.

## ◆ Punycode_status

enum Punycode_status

Enumerator
PUNYCODE_SUCCESS |
PUNYCODE_BAD_INPUT |
PUNYCODE_BIG_OUTPUT |
PUNYCODE_OVERFLOW |

Definition at line 100 of file punycode.h.

## Function Documentation

## ◆ punycode_decode()

IDNAPI int punycode_decode | ( | size_t | input_length,
|  | const char | input[],
|  | size_t * | output_length,
|  | punycode_uint | output[],
|  | unsigned char | case_flags[]
| ) |  |

punycode_decode:

Parameters

  input_length | The number of ASCII code points in the array.
  input | An array of ASCII code points (0..7F).
  output_length | The caller passes in the maximum number of code points that it can receive into the array (which is also the maximum number of flags that it can receive into the array, if is not a NULL pointer). On successful return it will contain the number of code points actually output (which is also the number of flags actually output, if case_flags is not a null pointer). The decoder will never need to output more code points than the number of ASCII code points in the input, because of the way the encoding is defined. The number of code points output cannot exceed the maximum possible value of a punycode_uint, even if the supplied is greater than that.
  output | An array of code points like the input argument of punycode_encode() (see above).
  case_flags | A NULL pointer (if the flags are not needed by the caller) or an array of boolean values parallel to the array. Nonzero (true, flagged) suggests that the corresponding Unicode character be forced to uppercase by the caller (if possible), and zero (false, unflagged) suggests that it be forced to lowercase (if possible). ASCII code points (0..7F) are output already in the proper case, but their flags will be set appropriately so that applying the flags would be harmless.

Converts Punycode to a sequence of code points (presumed to be Unicode code points).

Return value: The return value can be any of the Punycode_status values defined above. If not PUNYCODE_SUCCESS, then , , and might contain garbage.

Definition at line 345 of file punycode.c.

## ◆ punycode_encode()

IDNAPI int punycode_encode | ( | size_t | input_length,
|  | const punycode_uint | input[],
|  | const unsigned char | case_flags[],
|  | size_t * | output_length,
|  | char | output[]
| ) |  |

punycode_encode:

Parameters

  input_length | The number of code points in the array and the number of flags in the array.
  input | An array of code points. They are presumed to be Unicode code points, but that is not strictly REQUIRED. The array contains code points, not code units. UTF-16 uses code units D800 through DFFF to refer to code points 10000..10FFFF. The code points D800..DFFF do not occur in any valid Unicode string. The code points that can occur in Unicode strings (0..D7FF and E000..10FFFF) are also called Unicode scalar values.
  case_flags | A NULL pointer or an array of boolean values parallel to the array. Nonzero (true, flagged) suggests that the corresponding Unicode character be forced to uppercase after being decoded (if possible), and zero (false, unflagged) suggests that it be forced to lowercase (if possible). ASCII code points (0..7F) are encoded literally, except that ASCII letters are forced to uppercase or lowercase according to the corresponding case flags. If is a NULL pointer then ASCII letters are left as they are, and other code points are treated as unflagged.
  output_length | The caller passes in the maximum number of ASCII code points that it can receive. On successful return it will contain the number of ASCII code points actually output.
  output | An array of ASCII code points. It is not null-terminated; it will contain zeros if and only if the contains zeros. (Of course the caller can leave room for a terminator and add one if needed.)

Converts a sequence of code points (presumed to be Unicode code points) to Punycode.

Return value: The return value can be any of the Punycode_status values defined above except PUNYCODE_BAD_INPUT. If not PUNYCODE_SUCCESS, then and might contain garbage.

Definition at line 196 of file punycode.c.

## ◆ punycode_strerror()

IDNAPI const char* punycode_strerror | ( | Punycode_status | rc | ) |

punycode_strerror:

Parameters

  rc | an Punycode_status return code.

Convert a return code integer to a text string. This string can be used to output a diagnostic message to the user.

PUNYCODE_SUCCESS: Successful operation. This value is guaranteed to always be zero, the remaining ones are only guaranteed to hold non-zero values, for logical comparison purposes. PUNYCODE_BAD_INPUT: Input is invalid. PUNYCODE_BIG_OUTPUT: Output would exceed the space provided. PUNYCODE_OVERFLOW: Input needs wider integers to process.

Return value: Returns a pointer to a statically allocated string containing a description of the error with the return code .

Definition at line 57 of file strerror-punycode.c.